#include "fwserv.h"
#include "config.h"

char *gen_capabs (void);

static char *capabs[] =
{
#if defined(IRCD_HYB6) || defined(IRCD_HYB7) || defined(IRCD_HYBSVS)
  "QS",
#endif

#if defined(IRCD_HYB7) || defined(IRCD_HYBSVS)
  "KLN",
  "HUB",
  "HOPS",
  "AOPS",
  "EOB",
#endif

#ifdef IRCD_HYBSVS
  "HYBSVS",
  "SVSHOST",
  "SVSNICK",
  "SVSMODE",
  "SVS",
  "MASKIP",
#endif

#ifdef USE_MYSQL
  "MYSQL",
#endif

  NULL
};

char *gen_capabs (void)
{
  static char buf[BUFSIZE];
  int i;

  buf[0] = '\0';

  for (i=0; capabs[i] != NULL; i++)
  {
    if (buf[0] == '\0')
      strlcat(buf, capabs[i], BUFSIZE);
    else
    {
      strlcat(buf, " ", BUFSIZE);
      strlcat(buf, capabs[i], BUFSIZE);
    }
  }

  return buf;
}
