#include "fwserv.h"

void del_connection (int);

void
del_connection (int fd)
{
  dlink_node *dl;
  struct Connection *conn;

  DLINK_FOREACH(dl, connection_list.head)
    {
      conn = (struct Connection *)dl->data;
      if (conn->fd == fd)
        {
          dlink_delete(dl, &connection_list);
          free(conn);
          dlink_free(dl);
          return;
        }
    }
}
