#include "fwserv.h"
#include "ircd.h"
#include "chanserv.h" /* IsGuardSet() */
#include "channel.h"

void SetTopic (struct RChannel *channel)
{
	if (!IsGuardSet(channel))
	{
		ServerJoin (ChanServ.nick, channel->name);
		sts(":%s MODE %s +o %s", me.name, channel->name, ChanServ.nick);
	}

	sts(":%s TOPIC %s :%s", ChanServ.nick, channel->name, channel->topic);

	if (!IsGuardSet(channel))
		sts(":%s PART %s :Leaving", ChanServ.nick, channel->name);

	return;
}

void ServerJoin (char *nick, char *channel)
{
	struct Channel	*chan;

	chan = FindChannel(channel);

	if(!chan)
		AddChannel(channel, time(NULL));

	chan = FindChannel(channel);

	sts (":%s SJOIN %ld %s +nt :%s", me.name, chan->ts, chan->name, nick);

	return;
}
