#include "fwserv.h"
#include "config.h"
#include "utils.h"

#include "nickserv.h"


/*
#ifdef MYSQL_BACKEND
  #include <mysql.h>
#endif

void SaveDatabases (void);

void SaveDatabases (void)
{
  struct nickreg *nickreg;
  dlink_node *dl;

#ifdef MYSQL_BACKEND
  MYSQL *conn;
  char query[BUFSIZE];

  conn = connect_db();
#endif

  DLINK_FOREACH(dl, nickreg_list.head)
  {
    nickreg = (struct nickreg *)dl->data;
#ifdef MYSQL_BACKEND
    sprintf(query, "INSERT INTO NickServ VALUES ('%s', '%s')", nickreg->nick, nickreg->pass);

    if (mysql_query (conn, query) < 0)
    {
      log(1, "SaveDatabases failed: %s", mysql_error(conn));
      return;
    }

#endif

#ifdef MYSQL_BACKEND
  mysql_close(conn);
#endif
}*/

void
send_help_file (struct User *to, char *from, char *filename, char *query)
{
  FILE *fp = fopen(filename, "r");
  char buf[BUFSIZE];

  if (!fp)
  {
    notice(to, from, "No help available for: %s", query);
    return;
  }
  while (fgets(buf, BUFSIZE, fp))
  {
    strip(buf);
    if (buf[0])
      notice(to, from, "%s", buf);
    else
      notice(to, from, " ");
  }

  fclose(fp);
  return;
}

/* Remove CR and LF from the line input.  ASSUME that the line
** does NOT contain CR or LF in the middle
*/
void strip(char *line)
{
        char *c;
        int len;

        if ((c = strchr(line, '\r')))
        {
                /* If we receive a CR, then we can just terminate the
                ** call there.
                **
                ** Not any longer :(  - We have to pare off the spaces
                ** at the end of lines
                */
                *c = '\0';
        }

        if ((c = strchr(line, '\n')))
        {
                *c = '\0';
        }

        /* Strip out trailing spaces, which can cause odd issues with
        ** SplitServ's channel and other things
        */
        len = strlen(line);
        while (len > 0)
        {
                if (line[len - 1] == ' ')
                {
                        line[len - 1] = '\0';
                        len--;
                }
                else
                {
                        break;
                }
        }

        return;
}

/* print a period of seconds into human readable format */
char *timediff(time_t u)
{
        static char buf[TIMEBUF];

        if (u > 86400)
        {
                time_t days = u/86400;

                snprintf(buf, TIMEBUF, "%ld day%s, %02ld:%02ld",
                        days, (days == 1) ? "" : "s",
                        (u/3600) % 24, (u/60) % 60);
        }
        else if (u > 3600)
        {
                time_t hours = u/3600;
                time_t minutes = (u/60) % 60;

                snprintf(buf, TIMEBUF, "%ld hour%s, %ld minute%s",
                        hours, (hours == 1) ? "" : "s", minutes,
                        (minutes == 1) ? "" : "s");
        }
        else
        {
                time_t minutes = u/60;
                time_t seconds = u%60;

                snprintf(buf, TIMEBUF,
                        "%ld minute%s, %ld second%s",
                        minutes, (minutes == 1) ? "" : "s",
                        seconds, (seconds == 1) ? "" : "s");
        }

        return buf;
}

void
fmt_output (struct User *u, char *sender, char *message)
{
  char buffer[BUFSIZE * 2];
  char *buf;

  log(1, "I MADE IT HERE");

  if (u == NULL)
  {
    log(1, "u == NULL");
    return;
  }

  if (sender == NULL)
  {
    log(1, "sender == NULL");
    return;
  }

  if (message == NULL)
  {
    log(1, "message == NULL");
    return;
  }

  /*if ((buf = strchr(message, '\n')) != NULL) { *buf = '\0'; buf++; }*/

  return;

  while (( buf = strchr(message, '\n')))
  {
    /**buf = '\0';
    message++;*/

    strlcpy(buffer, message, BUFSIZE * 2);
    log(1, "%s", buffer);
    continue;
  }
  return;

  /*log(1, "fmt_output( %s, %s, %s )", u->nick, sender, message);*/

  if ((buf = strstr(message, "||")) != NULL) { *message = '\0'; message++; }

  notice(u, sender, buf);

  return;

  while (( buf = strchr(message, '\n')))
  {
    *buf = '\0';
    buf++;
    /*notice(u, sender, buf);*/

    log(1, "I MADE IT!");
    /*debug("D: %s", message);*/
    continue;
  }

  log(1, "AND HERE");
}

#if defined(IRCD_HYB6) || defined(IRCD_HYB7) || defined(IRCD_HYBSVS)
int sjtoken(char *message, char **parv)
{
        char *next;
        int count;

        if (!message)
        {
                /* Something is seriously wrong...bail */
                return -1;
        }

        /* Now we take the beginning of message and find all the spaces...
        ** set them to \0 and use 'next' to go through the string
        */
        next = message;

        /* Eat any initial delimiters */
        while (*next == ' ')
                next++;

        parv[0] = next;
        count = 1;

        while (*next)
        {
                /* This is fine here, since we don't have a :delimited
                ** parameter like tokenize
                */
                if (count == SJPARA)
                {
                    /* We've reached our limit */
                    debug("Reached the SJPARA limit!");
                    return count;
                }
                if (*next == ' ')
                {
                        *next = '\0';
                        next++;
                        /* Eat any additional delimiters */
                        while (*next == ' ')
                                next++;
                        /* If it's the end of the string, it's simply
                        ** an extra space at the end.  Here we break.
                        */
                        if (*next == '\0')
                                break;
                        /* If it happens to be a stray \r, break too */
                        if (*next == '\r')
                                break;
                        parv[count] = next;
                        count++;
                }
                else
                {
                        next++;
                }
        }

        return count;
}
#endif

int is_channel (char *c)
{
  if (c != NULL)
  {
    if ((c[0] == '#') || (c[0] == '+') || (c[0] == '&'))
      return TRUE;

    return FALSE;
  }

  return FALSE;
}

void ExpandParv(char *dest, int max, int initial, int parc, char *parv[])
{
  int i;

  if (parv[initial])
    strlcpy(dest, parv[initial], max);
  for (i = initial + 1; i < parc; i++)
  {
    strlcat(dest, " ", max);
    strlcat(dest, parv[i], max);
  }
}
