CREATE TABLE NickServ
(
  nick TEXT NOT NULL,
  password TEXT NOT NULL,
  flags INT NOT NULL DEFAULT 0,
  last_seen INT UNSIGNED NOT NULL DEFAULT 0,
  last_quit TEXT,
  registered INT UNSIGNED NOT NULL DEFAULT 0,
  email TEXT,
  url TEXT,
  last_address TEXT
);

CREATE TABLE ChanServ
(
  name TEXT NOT NULL,
  topic TEXT NOT NULL,
  password TEXT NOT NULL,
  description TEXT NOT NULL,
  founder TEXT NOT NULL
);

CREATE TABLE MemoServ
(
  tonick TEXT NOT NULL,
  fromnick TEXT NOT NULL,
  memo TEXT NOT NULL,
  time_sent INT UNSIGNED NOT NULL DEFAULT 0,
  flags INT NOT NULL DEFAULT 0,
  id INT UNSIGNED NOT NULL DEFAULT 0
);

CREATE TABLE NickLinks
(
  master TEXT NOT NULL,
  nick TEXT NOT NULL
);

CREATE TABLE NickAccess
(
  nick TEXT NOT NULL,
  host TEXT NOT NULL
);

CREATE TABLE ChannelLevels (
channel TEXT NOT NULL,
autodeop INT NOT NULL DEFAULT -1,
autovoice INT NOT NULL DEFAULT 5,
autoop INT NOT NULL DEFAULT 10,
cmdvoice INT NOT NULL DEFAULT 5,
cmdop INT NOT NULL DEFAULT 10,
access INT NOT NULL DEFAULT 5,
invite INT NOT NULL DEFAULT 5,
autohop INT NOT NULL DEFAULT 8,
cmdhop INT NOT NULL DEFAULT 8,
unban INT NOT NULL DEFAULT 8,
akick INT NOT NULL DEFAULT 15,
clear INT NOT NULL DEFAULT 20,
set INT NOT NULL DEFAULT 25,
sop INT NOT NULL DEFAULT 40);
