#define CS_GUARD		0x00000001
#define CS_SECURE		0x00000002
#define CS_TOPICLOCK	0x00000004

#define CS_DELETE		0x10000000

#define IsGuardSet(x)	((x)->flags & CS_GUARD)
#define IsTopicLock(x)	((x)->flags & CS_TOPICLOCK)
#define IsSecure(x)		((x)->flags & CS_SECURE)

/* Level Options */
#define LEVEL_AOP		0x00000001
#define LEVEL_HOP		0x00000002
#define LEVEL_VOP		0x00000004
#define LEVEL_ACCESS	0x00000008
#define LEVEL_CMDOP		0x00000010
#define LEVEL_SET		0x00000020
#define LEVEL_SOP		0x00000040
#define LEVEL_AKICK		0x00000080
#define LEVEL_UNBAN		0x00000100
#define LEVEL_CLEAR		0x00000200
#define LEVEL_CMDVOICE	0x00000400
#define LEVEL_INVITE	0x00000800

void DelChannel (char *);

void FlushChanServTable (void);
void JoinChannels (void);
struct RChannel *FindRChannel (char *);
