dlink_list nickreg_list;

#define NS_IDENTIFIED	0x00000001
#define NS_KILL		0x00000002
#define NS_NOEXPIRE	0x00000004
#define NS_AUTOMASK	0x00000008
#define NS_SECURE	0x00000010
#define NS_ALLOWMEMO	0x00000020
#define NS_MEMONOTIFY	0x00000040
#define NS_MEMOSIGNON	0x00000080

#define NS_DELETE		0x10000000

#define Identified(x)	((x)->flags & NS_IDENTIFIED)

struct nickreg
{
  char nick[NICKLEN];
  char pass[512];

  int flags;
};

void ChageNick (char *, char *);
char *NickOptions (int);

void FlushNickServTable (void);
int IsLinked (char *, char *);

void AddNick (struct User *, char *);
void DelNick (char *);
struct Nick *FindNick (char *);
