#include "fwserv.h"
#include "token.h"
#include "flags.h"
#include "nickserv.h" /* NickServ Flags */
#include "chanserv.h" /* ChanServ Flags */

struct Token oper_flags[] =
{
    { "OPERATOR",   OFLAG_OPER },
    { "ADMIN",	    OFLAG_ADMIN },
    { NULL,	    TOKEN_ERROR }
};

struct Token nick_flags[] =
{
    { "AUTOKILL",   NS_KILL },
    { "NOEXPIRE",   NS_NOEXPIRE },
    { "AUTOMASK",   NS_AUTOMASK },
    { "SECURE",	    NS_SECURE },
    { "MEMO",	    NS_ALLOWMEMO },
    { "MEMONOTIFY", NS_MEMONOTIFY },
    { "MEMOSIGNON", NS_MEMOSIGNON },
    { NULL,	TOKEN_ERROR }
};

struct Token chan_flags[] =
{
    { "GUARD",	    CS_GUARD },
    { "SECURE",	    CS_SECURE },
    { NULL,	    TOKEN_ERROR }
};

struct Token log_flags[] =
{
	{ "L_ERROR",	L_ERROR },
	{ "L_WARN",		L_WARNING },
	{ "L_NOTICE",	L_NOTICE },
	{ "L_INFO",		L_INFO },
	{ "L_DEBUG",	L_DEBUG },
	{ NULL,			TOKEN_ERROR }
};
